<template>
  <b-modal
    id="modalQueryConfirm"
    :ok-title="'Confirmar'"
    :cancel-title="'Cancelar'"
    @ok="handleOk"
    title="Deseja realmente agendar essa consulta?">
    <b-row>
      <b-col>
        <div>
          <ul>
            <li v-if="query">
              <strong>Paciente:</strong> 
              {{ query.paciente }}
            </li>
            <li>
              <strong>Data:</strong> 
              {{ query.dataFormatada }}
            </li>
            <li>
              <strong>Observação: </strong>
              {{ query.observacao }}
            </li>
          </ul>
        </div>
      </b-col>
    </b-row>
  </b-modal>
</template>

<script>
import { mapActions } from 'vuex'
import QueryService from '@/services/queryservice'

export default {
  name: 'query-confirm',

  props: {
    query: {
      default: {
        dataConsulta: null,
        dataFormatada: null,
        idMedico: 0,
        observacao: null,
        paciente: null
      }
    }
  },

  created() {
    this.queryService = new QueryService()
  },


  methods: {
    ...mapActions([
      'controlFeedbackVisibilite'
    ]), 

    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault()
      // Trigger submit handler
      this.handleSubmit()
    },

    handleSubmit() {
      const query = delete this.query.dataFormatada;
      this.queryService.addQuery(this.query).then((response) => {
        console.log(response)
        const paramSuccess = { type: 'success', msg: true }
        this.controlFeedbackVisibilite(paramSuccess)
      }).catch((error) => {
        const paramError = { type: 'error', msg: true }
        this.controlFeedbackVisibilite(paramError)
        console.log(error)
      }).finally(() => {
        this.$nextTick(() => {
          this.$bvModal.hide('modalQueryConfirm')
        })
         setTimeout(() => {
          const paramSuccess = { type: 'success', msg: false }
          this.controlFeedbackVisibilite(paramSuccess)

          const paramError = { type: 'error', msg: false }
          this.controlFeedbackVisibilite(paramError)
        }, 3000)
      })
    }
  }
}
</script>

<style lang="scss">
</style>